// DlgOption.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PPTimer.h"
#include "DlgOption.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char* CDlgOption::s_fileName = "PPTimer.txt";

/////////////////////////////////////////////////////////////////////////////
// CDlgOption _CAO


CDlgOption::CDlgOption(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOption::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgOption)
	m_str = _T("");
	m_tim = _T("");
	m_delay = 0;
	m_elapse = 0;
	m_last = _T("");
	m_bNotShowTime = FALSE;
	m_wav = _T("");
	//}}AFX_DATA_INIT
//	m_elapse = 0;
	m_delay = 10;
	m_col1.m_color = RGB(255,255,255);
	m_col2.m_color = RGB(0,0,0);
	m_bOutShow = false;
	m_pos = CPoint(1,1);
	m_it = m_data.begin();
}


void CDlgOption::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOption)
	DDX_Control(pDX, IDC_COL2, m_col2);
	DDX_Control(pDX, IDC_COL1, m_col1);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_STR, m_str);
	DDX_Text(pDX, IDC_TIM, m_tim);
	DDX_Text(pDX, IDC_DELAY, m_delay);
	DDX_Text(pDX, IDC_ELAPSE, m_elapse);
	DDX_Text(pDX, IDC_LAST, m_last);
	DDX_Check(pDX, IDC_NOT_SHOW_TIME, m_bNotShowTime);
	DDX_Text(pDX, IDC_WAV, m_wav);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOption, CDialog)
	//{{AFX_MSG_MAP(CDlgOption)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_CLR, OnClr)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_BN_CLICKED(IDC_WAV_REF, OnWavRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOption bZ[W nh

CString Time2Str(int t)
{
	CString	s;
	s.Format("%.2d:%.2d",(t/60)%60,t%60);
	return s;
}

int Str2Time(const char* p)
{
	int		i;
	i = atoi(p)*60;
	const char*	q = strchr(p,':');
	if (q && q[1]) {
		i += atoi(q+1);
	}
	return i;
}

void CDlgOption::Set(const CDlgOption& d)
{
	if (this == &d) return;
	m_pos = d.m_pos;
	m_data = d.m_data;
	m_it = m_data.begin();
	m_col1.m_color = d.m_col1.m_color;
	m_col2.m_color = d.m_col2.m_color;
	m_delay = d.m_delay;
	m_elapse = d.m_elapse;
	m_last = d.m_last;
	m_bNotShowTime = d.m_bNotShowTime;
	m_wav = d.m_wav;
}

void CDlgOption::Save()
{
	FILE*	f = fopen(s_fileName,"w");
	if (!f) return;
	const int ver = 110;
	fprintf(f,"%d\n",ver);
	fprintf(f,"%d %d\n%d %d %d\n",
		max(1,m_pos.x),max(1,m_pos.y),
		m_col1.m_color,m_col2.m_color,m_bNotShowTime);
	fprintf(f,"%d\n%s\n",m_delay,(const char*)m_last);
	fprintf(f,"%d\n",m_data.size());
	map<int,CTimeData>::iterator	it;
	for (it=m_data.begin();it!=m_data.end();++it) {
		CTimeData& td = it->second;
		fprintf(f,"%d\n%s\n%s\n",it->first,
			(const char*)td.m_msg,(const char*)td.m_wav);
	}
	fclose(f);
}

void CDlgOption::Load()
{
	FILE*	f = fopen(s_fileName,"r");
	if (!f) return;
	int		i,k,n,ver = -1;
	char	buf[1024],*p;
	fgets(buf,sizeof(buf),f);	// o[W
	sscanf(buf,"%d",&ver);
	fgets(buf,sizeof(buf),f);
	sscanf(buf,"%d %d",&m_pos.x,&m_pos.y);
	fgets(buf,sizeof(buf),f);
	m_bNotShowTime = 0;
	sscanf(buf,"%d %d %d",&m_col1.m_color,&m_col2.m_color,&m_bNotShowTime);
	fgets(buf,sizeof(buf),f);
	sscanf(buf,"%d",&m_delay);
	fgets(buf,sizeof(buf),f);
	p = buf+strlen(buf)-1;
	if (*p == '\n') *p = 0;
	m_last = buf;
	fgets(buf,sizeof(buf),f);
	n = 0;
	sscanf(buf,"%d",&n);
	m_data.clear();
	for (i=0;i<n;++i) {
		fgets(buf,sizeof(buf),f);
		sscanf(buf,"%d",&k);
		fgets(buf,sizeof(buf),f);
		p = buf+strlen(buf)-1;
		if (*p == '\n') *p = 0;
		CTimeData& td = m_data[k];
		td.m_msg = buf;
		if (ver >= 110) {
			fgets(buf,sizeof(buf),f);
			p = buf+strlen(buf)-1;
			if (*p == '\n') *p = 0;
			td.m_wav = buf;
		}
	}
	fclose(f);
	m_it = m_data.begin();
	m_elapse = 0;
}

void CDlgOption::ResetList()
{
	int		i;
	map<int,CTimeData>::iterator	it;
	m_list.SetRedraw(FALSE);
	m_list.DeleteAllItems();
	for (i=0, it=m_data.begin();it!=m_data.end();++it, ++i) {
		CTimeData& td = it->second;
		m_list.InsertItem(i,Time2Str(it->first));
		m_list.SetItemText(i,1,td.m_msg);
		m_list.SetItemText(i,2,td.m_wav);
	}
	m_list.SetRedraw();
}

void CDlgOption::OnAdd() 
{
	if (!UpdateData()) return;
	if (m_tim.IsEmpty()) {
		MB("ݒ肵ĉ");
		GetDlgItem(IDC_TIM)->SetFocus();
		return;
	}
	if (m_str.IsEmpty() && m_wav.IsEmpty()) {
		MB("bZ[Wݒ肵ĉ");
		GetDlgItem(IDC_STR)->SetFocus();
		return;
	}
	int	t = Str2Time(m_tim);
	CTimeData& td = m_data[t];
	td.m_msg = m_str;
	td.m_wav = m_wav;
	ResetList();
}

void CDlgOption::OnClr() 
{
	m_data.clear();
	m_it = m_data.begin();
	ResetList();
}

int CDlgOption::GetSel()
{
	if (m_list.GetSelectedCount() != 1)
		return -1;
	POSITION pos = m_list.GetFirstSelectedItemPosition();
	if (!pos) return -1;
	int i = m_list.GetNextSelectedItem(pos);
	return i;
}

void CDlgOption::OnDel() 
{
	int		k, i = GetSel();
	if (i < 0) return;
	m_it = m_data.begin();
	k = i;
	while (--i >= 0) ++m_it;
	m_data.erase(m_it);
	m_it = m_data.begin();
	ResetList();
//	if (k == m_data.size()) --k;
	m_list.SetItemState(k,LVIS_SELECTED,LVIS_SELECTED);
}

void CDlgOption::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	if (!UpdateData()) return;
	int		i = GetSel();
	if (i < 0) return;
	m_tim = m_list.GetItemText(i,0);
	m_str = m_list.GetItemText(i,1);
	m_wav = m_list.GetItemText(i,2);
	UpdateData(FALSE);
}

BOOL CDlgOption::OnInitDialog() 
{
	CDialog::OnInitDialog();
	const int	n = 3;
	const char* tit[] = {"","bZ[W","t@C"};
	int			wid[] = {36,120,300};
	int			i;
	ASSERT(sizeof(tit)/sizeof(*tit) == n);
	ASSERT(sizeof(wid)/sizeof(*wid) == n);
	for (i=0;i<n;++i)
		m_list.InsertColumn(i,tit[i], LVCFMT_LEFT, wid[i],i);
	ListView_SetExtendedListViewStyle(m_list.m_hWnd,LVS_EX_FULLROWSELECT);
	ResetList();
	if (m_bOutShow) {
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_ELAPSE)->ShowWindow(SW_HIDE);
	}
	return TRUE;
}

void CDlgOption::OnOK() 
{
	m_it = m_data.begin();
	CDialog::OnOK();
}

void CDlgOption::OnWavRef() 
{
	if (!UpdateData()) return;
	char	buf[512];
	getcwd(buf,sizeof(buf));
	CFileDialog	dlg(TRUE,"wav",m_wav,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Wave Files(*.wav)|*.wav||", this);
	if (dlg.DoModal() == IDOK) {
		m_wav = dlg.GetPathName();
		UpdateData(FALSE);
	}
	chdir(buf);
}
